leetcode之35 搜索插入位置

文章目录


每日碎碎念

苦痛生活继续

hello LeetCode,今天还是数组二分专项刷题...


一、题目要求及测试点

35 搜索插入位置

给定一个排序数组和一个目标值,在数组中找到目标值,并返回其索引。如果目标值不存在于数组中,返回它将会被按顺序插入的位置。

请必须使用时间复杂度为 O(log n) 的算法。

链接https://leetcode.cn/problems/search-insert-position/description/

测试点

示例 1:

复制代码
输入: nums = [1,3,5,6], target = 5
输出: 2

示例 2:

复制代码
输入: nums = [1,3,5,6], target = 2
输出: 1

示例 3:

复制代码
输入: nums = [1,3,5,6], target = 7
输出: 4

提示

  • 1 < = n u m s . l e n g t h < = 1 0 4 1 <= nums.length <= 10^4 1<=nums.length<=104
  • − 1 0 4 < = n u m s i < = 1 0 4 -10^4 <= numsi <= 10^4 −104<=numsi<=104
  • nums 为 无重复元素 的升序 排列数组
  • − 1 0 4 < = t a r g e t < = 1 0 4 -10^4 <= target <= 10^4 −104<=target<=104

二、题解

自己上手

代码如下:

c 复制代码
class Solution {
public:
    int searchInsert(vector<int>& nums, int target) { 
        int left = 0; 
        int right = nums.size() - 1; 
        int middle = left + ((right - left) / 2); 
        while (left <= right){ 
            middle = left + ((right - left) >> 1); 
            if (target < nums[middle])
                right = middle - 1; 
            else if (target > nums[middle])
                left = middle + 1; 
            else
                return middle; 
        }
        if (target > nums[middle])
            return (middle + 1); 
        else
            return middle;  
    }
};

来点无用总结:

时间复杂度O(logn),如果找到就是二分,重点是没找到的插入,肯定是循环退出right<left的情况啦,如果target>numsmiddle,这时显然后插middle+1,不然就插在当前middle位置...

正经题解

提示中已说明该数列有序,且无重复,考虑二分; 当然,暴力解法不一定时间消耗就很高...

数组中插入目标值有四种情况:

  • 目标值在数组所有元素之前
  • 目标值等于数组中某一个元素
  • 目标值插入数组中的位置
  • 目标值在数组所有元素之后

暴力法

暴力的逻辑简单,因为原数列就有序,就从左到右遍历,一旦发现target<=数组中某个数,就返回该数下标即可;如果遍历完,考虑万一插在数列最后的情况,即返回数列长度即可

c 复制代码
class Solution {
public:
    int searchInsert(vector<int>& nums, int target) { 
        for (int i=0; i < nums.size(); i++){ 
            if (target <= nums[i])
                return i; 
        }
        return nums.size(); 
    }
};

时间复杂度:O(n),空间复杂度:O(1)

二分法之优化了一下逻辑

c 复制代码
class Solution {
public:
    int searchInsert(vector<int>& nums, int target) { 
        int left = 0; 
        int right = nums.size() - 1; 
        while (left <= right){ 
            int middle = left + ((right - left) >> 1); 
            if (target < nums[middle])
                right = middle - 1; 
            else if (target > nums[middle])
                left = middle + 1; 
            else
                return middle; 
        }
            return left;  //right+1
    }
};

当最后middle=left=right即将退出时

target<numsmiddle,left=middle,right=middle-1,要插middle位置,即返回left或者right+1;

target>numsmiddle,right=middle,left=middle+1,要插middle+1位置,即返回left或者right+1;

两种情况合并即可


时间复杂度:O(log n),空间复杂度:O(1)

三、总结

1.注意二分法使用前提;

2.理清楚边界条件

3.nums.size(),编程规范注意一下

相关推荐
徐小黑ACG2 小时前
Golang 基础05 结构体struct
开发语言·算法·golang
Navigator_Z2 小时前
LeetCode //C - 1286. Iterator for Combination
c语言·算法·leetcode
北极有牛3 小时前
cpp学习笔记--常量指针
java·开发语言·算法
GPU实战笔记3 小时前
云端 GPU 训练的账户余额提醒:它能说明什么,不能说明什么?
深度学习·算法·成本管理·gpu云计算·云端训练
半杯咖啡半行码3 小时前
C++ 编程与 STL 模板:从泛型编程到内存安全详解
开发语言·c++
浮链序3 小时前
怎么证明"你这个模型是偷我的"——把蒸馏变成取证工具
算法·安全·llm
小O的算法实验室3 小时前
IEEE TMC,面向异构物联网的多目标量子行为拓扑优化算法
算法
圣保罗的大教堂4 小时前
leetcode 301. 删除无效的括号 困难
leetcode
liliangcsdn4 小时前
派息率指标的应用探索和分析
大数据·算法
xh didida4 小时前
Linux -- 基础IO
linux·服务器·开发语言·c++